# SPDX-FileCopyrightText: The Nirvati developers
#
# SPDX-License-Identifier: AGPL-3.0-or-later

version: 1

containers:
  main:
    ingress_port: 3000
    image: btcpayserver/btcpayserver:2.0.3
    entrypoint:
      - dotnet
      - BTCPayServer.dll
    environment:
      HOME: /data
      BTCPAY_DATADIR: /data
      BTCPAY_PLUGINDIR: /data/plugins
      BTCPAY_DOCKERDEPLOYMENT: "false"
      BTCPAY_POSTGRES: User
        ID=postgres;Host=postgres.btcpay-server.{{user}}.nirvati;Port=5432;Application
        Name=btcpayserver;Database=btcpayserver{{ plugins.bitcoin.info.network }}
      BTCPAY_NETWORK: {{ plugins.bitcoin.info.network }}
      BTCPAY_BIND: 0.0.0.0:3000
      BTCPAY_CHAINS: btc
      BTCPAY_BTCEXPLORERURL: http://nbxplorer.btcpay-server.{{user}}.nirvati:32838
      BTCPAY_SOCKSENDPOINT: proxy.tor.nirvati:9050
      {% if installed_apps is containing("lnd") %}
      BTCPAY_BTCLIGHTNING: "type=lnd-rest;server=https://main.lnd.{{user}}.nirvati:8080/;macaroon={{ plugins.lnd.auth.macaroons.btcpay }};allowinsecure=true" # TODO: Encrypt connections; there is not really a security risk here because all connections are local, but good to have anyway
      {% endif %}
    mounts:
      data:
        nbxplorer/data: /data/.nbxplorer
        main/data: /data
    user: 1000:1000
  nbxplorer:
    internal_ports:
      32838: 32838
    image: nicolasdorier/nbxplorer:2.5.12
    user: 1000:1000
    environment:
      NBXPLORER_DATADIR: /data
      NBXPLORER_NETWORK: {{ plugins.bitcoin.info.network }}
      NBXPLORER_PORT: "32838"
      NBXPLORER_BIND: 0.0.0.0
      NBXPLORER_CHAINS: btc
      NBXPLORER_SIGNALFILEDIR: /data
      NBXPLORER_BTCRPCURL: http://gateway.bitcoin.{{user}}.nirvati:8332
      NBXPLORER_BTCNODEENDPOINT: bitcoin.bitcoin.{{user}}.nirvati:8333
      NBXPLORER_BTCRPCUSER: btcpay-server-{{user}}-main
      NBXPLORER_BTCRPCPASSWORD: {{ plugins.bitcoin.info.account_passwords.main }}
      NBXPLORER_POSTGRES: User
        ID=postgres;Host=postgres.btcpay-server.{{user}}.nirvati;Port=5432;Application
        Name=nbxplorer;MaxPoolSize=20;Database=nbxplorer{{ plugins.bitcoin.info.network }}
      NBXPLORER_AUTOMIGRATE: "1"
      NBXPLORER_NOMIGRATEEVTS: "1"
    mounts:
      data:
        nbxplorer/data: /data
  postgres:
    image: postgres:16.1
    internal_ports:
      tcp:
        5432: 5432
    mounts:
      data:
        db/postgres: /var/lib/postgresql/data
    environment:
      POSTGRES_HOST_AUTH_METHOD: trust
